//////////////////////////////////////////////////////////////////////
// SerialPro.cpp: implementation of the CSerialPro class.
//봮бͨѶԱ
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "EPro.h"
#include "SerialPro.h"
#include "Pro.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSerialPro::CSerialPro()
{
	m_bCanUse=FALSE;
	m_bPort=FALSE;
	m_bThread=FALSE;
	m_hReadRsp=CreateEvent(NULL,FALSE,FALSE,NULL);
	m_hWriteRsp=CreateEvent(NULL,FALSE,FALSE,NULL);
}

CSerialPro::~CSerialPro()
{

}

//18ֽڣ1ֽڱʾͣ2ֽڱʾFID
//16ֽòص
BOOL CSerialPro::SendData()
{
	if(!m_bPort)
	{
		m_pPro->Notify(PRO_INIT_SERIAL_NOT);
		return FALSE;
	}
	if(m_bCanUse)
	{
		TRACE("[0]%2x [1]%2x [2]%2x [3]%2x [4]%2x [5]%2x [6]%2x [7]%2x\n",TxdBuf[0],TxdBuf[1],TxdBuf[2],TxdBuf[3],TxdBuf[4],TxdBuf[5],TxdBuf[6],TxdBuf[7]);
		SendBlock(TxdBuf,18);
		m_bCanUse=FALSE;
		return TRUE;
	}
	else
	{
		m_pPro->Notify(PRO_INVALID);
		return FALSE;
	}
}

//ָݿĴ
void CSerialPro::OnReceived(BYTE *pBuf, UINT nLength)
{
	static int n=0;
	n++;
	TRACE("%d-OnReceived %d BYTES\n",n,nLength);
	TRACE("[0]%2x [1]%2x [2]%2x [3]%2x [4]%2x [5]%2x [6]%2x [7]%2x\n",pBuf[0],pBuf[1],pBuf[2],pBuf[3],pBuf[4],pBuf[5],pBuf[6],pBuf[7]);
	if(nLength==18)
	{
		switch(pBuf[0])//ʲôĻӦ
		{
		case 0://
			m_bCanUse=TRUE;
			m_pPro->Notify(PRO_AVAILABLE);
			return;
		case 1://
			m_bCanUse=TRUE;
			m_pPro->SignByte[0]=pBuf[2];
			m_pPro->SignByte[1]=pBuf[3];
			m_pPro->SignByte[2]=pBuf[4];
			m_pPro->CheckChip();//Ƿҵƥ
			return;
		case 2://
			m_bCanUse=TRUE;
			m_pPro->Notify(PRO_ERASE);
			return;
		case 3:
			//ȴдĻӦдROM߳
			TRACE("m_bThread=%d\n",m_bThread);
			if(m_bThread==FALSE?(AfxBeginThread(WriteRomThread,this)!=NULL):FALSE)
				return;
		case 4:
			//ȴĻӦROM߳
			TRACE("m_bThread=%d\n",m_bThread);
			if(m_bThread==FALSE?(AfxBeginThread(ReadRomThread,this)!=NULL):FALSE)
				return;
		case 5://дλ
			m_bCanUse=TRUE;
			m_pPro->Notify(PRO_LOCK_BIT);
			return;
		case 6://
		 if(m_bThread)
		 {
			SetEvent(m_hReadRsp);//¼֪ͨ߳
		 }
			return;
		case 0xff://յЧ
			m_bCanUse=TRUE;
			m_pPro->Notify(PRO_WORK_INVALID);
			return;
		default:
			m_bCanUse=TRUE;
			break;
		}
	}
	else if(nLength==1 && m_bThread)//ֻյ1ֽڣǷд̵߳ 
	{
		//ΪͨѶЧʣдһݺӦһֽ
		//ʾǷɹд
		SetEvent(m_hWriteRsp);//¼֪ͨд߳
	}
	else//ͨѶ
	{
		m_pPro->Notify(PRO_RCV_ER);
		m_bCanUse=FALSE;
	}
}


BOOL CSerialPro::InitPort(CPro* pPro, UINT nPort, UINT nBaud)
{
	m_pPro=pPro;
	if(m_bPort)
	{
		StopMonitoring();//ǰռ˴ڣȹرռ
	}
	//ʼͨѶ
	m_bPort=CSerialPort::InitPort((CWnd*)pPro->m_pDlg,nPort,nBaud,'N');
	if(m_bPort)
	{
		SetExpRcv(18);//ݿ鳤
		StartMonitoring();//
		m_pPro->Notify(PRO_INIT_SERIAL_SEC);
		TRACE("CSerialPort::InitPort-PASS\n");
	}
	else
	{
		m_pPro->Notify(PRO_INIT_SERIAL_ER);
		TRACE("CSerialPort::InitPort-ERROR\n");
	}
	return m_bPort;
}

void CSerialPro::DetectPro(BYTE FID)
{
	TRACE("DetectPro(%d)\n",FID);
	TxdBuf[0]=0;
	TxdBuf[1]=FID;
	m_bCanUse=TRUE;
	SendData();
}

void CSerialPro::ReadSign(BYTE FID)
{
	TRACE("ReadSign(%d)\n",FID);
	TxdBuf[0]=1;
	TxdBuf[1]=FID;
	SendData();
}

void CSerialPro::Erase(BYTE FID)
{
	TRACE("Erase(%d)\n",FID);
	TxdBuf[0]=2;
	TxdBuf[1]=FID;
	SendData();	
}

//Ϳʼдñ׼
void CSerialPro::BeginWrite(BYTE FID)
{
	TRACE("BeginWrite(%d)\n",FID);
	TxdBuf[0]=3;
	TxdBuf[1]=FID;
	SendData();
}

//Ϳʼñ׼
void CSerialPro::BeginRead(BYTE FID)
{
	TRACE("BeginWrite(%d)\n",FID);
	TxdBuf[0]=4;
	TxdBuf[1]=FID;
	SendData();
}

void CSerialPro::LockBit(BYTE FID,int nBit)
{//дλnBitΪλ
	TRACE("LockBit(%d,%d)\n",FID,nBit);
	TxdBuf[0]=5;
	TxdBuf[1]=FID;
	TxdBuf[2]=(BYTE)nBit;
	SendData();
}

//д߳
UINT CSerialPro::WriteRomThread(LPVOID pParam)
{
	TRACE("WriteRomThread(LPVOID pParam)\n");
	CSerialPro* pSerialPro=(CSerialPro*)pParam;
	pSerialPro->m_bThread=TRUE;
	CPro* pPro=pSerialPro->m_pPro;
	pPro->Notify(PRO_WRITE_BEGIN);
	pPro->m_nAddr=0;
	pPro->m_nDataLength=pPro->GetMinLength(pPro->m_pWriteBuf,0x10000);
	//õСݿ鳤ȣд0xff
	if(pPro->m_nDataLength==0)//ݿ鳤Ϊ0ֱ˳
	{
		TRACE("WriteRomThread(...) Over\n");
		pSerialPro->m_bThread=FALSE;
		pSerialPro->TxdBuf[0]=0;//֪ͨд
		pSerialPro->SendBlock(pSerialPro->TxdBuf,18);
		pPro->Notify(PRO_WRITE_OVER);
		return 0;
	}
	pSerialPro->SetExpRcv(1);//ֻҪһֽ
	Sleep(5);
	ResetEvent(pSerialPro->m_hWriteRsp);//¼λ
	while(pPro->m_nAddr<pPro->m_nDataLength)
	{//ֻҪROMַָСݿ鳤ȣͼд
		TRACE("pPro->m_nAddr:%04x pPro->m_nDataLength:%04x\n",pPro->m_nAddr,pPro->m_nDataLength);
		pSerialPro->TxdBuf[0]=0x07;//ʾд
		memcpy(&pSerialPro->TxdBuf[2],&pPro->m_pWriteBuf[pPro->m_nAddr],0x10);
		//ͻҪд
		pSerialPro->SendBlock(pSerialPro->TxdBuf,18);//
		TRACE("WaitForSingleObject(...)\n");
		if(WaitForSingleObject(pSerialPro->m_hWriteRsp,1000)==WAIT_TIMEOUT)
		{//ȴӦʱ
			TRACE("WaitForSingleObject(...) TimeOut\n");
			pSerialPro->SetExpRcv(18);
			pPro->Notify(PRO_RCV_ER);
			pSerialPro->m_bThread=FALSE;
			pSerialPro->m_bCanUse=TRUE;
			return -1;
			
		}
		TRACE("WaitForSingleObject(...) OVER\n");
		if(pSerialPro->RxdBuf[0]==0x01)
		{//дݳɹ
			pPro->m_nAddr+=0x10;
			pPro->Notify(PRO_WRITE_BLOCK);
		}
		else if(pSerialPro->RxdBuf[0]==0xff)
		{//дʧ
			TRACE("WriteRomThread(...) ERROR\n");
			pSerialPro->SetExpRcv(18);
			pSerialPro->TxdBuf[0]=0;
			pSerialPro->SendBlock(pSerialPro->TxdBuf,18);
			pPro->Notify(PRO_WRITE_ER);
			pSerialPro->m_bThread=FALSE;
			pSerialPro->m_bCanUse=TRUE;
			return -1;
		}
		else//ͨѶ
		{
			TRACE("WriteRomThread(...) COM ER\n");
			pSerialPro->SetExpRcv(18);
			pPro->Notify(PRO_RCV_ER);
			pSerialPro->m_bThread=FALSE;
			pSerialPro->m_bCanUse=TRUE;
			return -1;
		}
	}
	pSerialPro->SetExpRcv(18);//ԭ
	pSerialPro->TxdBuf[0]=0;//֪ͨд
	pSerialPro->SendBlock(pSerialPro->TxdBuf,18);
	pPro->Notify(PRO_WRITE_OVER);
	TRACE("WriteRomThread(...) SEC\n");
	pSerialPro->m_bThread=FALSE;
	pSerialPro->m_bCanUse=TRUE;
	return 0;
}

//߳
UINT CSerialPro::ReadRomThread(LPVOID pParam)
{
	TRACE("ReadRomThread(LPVOID pParam)\n");
	CSerialPro* pSerialPro=(CSerialPro*)pParam;
	pSerialPro->m_bThread=TRUE;
	CPro* pPro=pSerialPro->m_pPro;
	pPro->Notify(PRO_READ_BEGIN);
	BYTE RespByte=1;
	BOOL bReWait=FALSE;
	pPro->m_nAddr=0;
	if(!pPro->m_bCheck)//Ч飬ROM
		pPro->m_nDataLength=pPro->GetCurChip()->RomSize*1024;
	if(pPro->m_nDataLength==0)
	{
		pPro->Notify(PRO_READ_OVER);
		TRACE("ReadRomThread(...) Over\n");
		pSerialPro->m_bThread=FALSE;
		return 0;
	}
	ResetEvent(pSerialPro->m_hReadRsp);//¼λ
	while(pPro->m_nAddr<pPro->m_nDataLength)
	{
		TRACE("pPro->m_nAddr:%04x pPro->m_nDataLength:%04x\n",pPro->m_nAddr,pPro->m_nDataLength);
		pSerialPro->SendBlock(&RespByte,1);//һֽڸ
		TRACE("WaitForSingleObject(...)\n");
		if(WaitForSingleObject(pSerialPro->m_hReadRsp,500)==WAIT_TIMEOUT)
		{//ȴӦʱ
			if(bReWait)//طʧ
			{
				RespByte=0;
				pSerialPro->SendBlock(&RespByte,1);
				pPro->Notify(PRO_RCV_ER);
				pSerialPro->m_bThread=FALSE;
				pSerialPro->m_bCanUse=TRUE;
				return -1;
			}
			else//Ҫط
			{
				RespByte=0xff;
				bReWait=TRUE;
				continue;
			}
		}
		bReWait=FALSE;
		TRACE("WaitForSingleObject(...) OVER\n");
		memcpy(&pPro->m_pReadBuf[pPro->m_nAddr],&pSerialPro->RxdBuf[2],0x10);
		//յݺ䵽
		pPro->m_nAddr+=0x10;
		RespByte=0x01;//ʾ
		pPro->Notify(PRO_READ_BLOCK);
	}
	RespByte=0;//ʾ
	pSerialPro->SendBlock(&RespByte,1);
	pPro->Notify(PRO_READ_OVER);
	pSerialPro->m_bThread=FALSE;
	pSerialPro->m_bCanUse=TRUE;
	TRACE("ReadRomThread(...) Over\n");
	return 0;
}


