///////////////////////////////////////////////////////////////////////////////////////////////////
//FID=01:AT89C2051ϵб
//ʵ̵ֱĶдϸ
//AT89C2051⴦:XTALһ壬ַ1;P1AT89C51෴Ҫúת
///////////////////////////////////////////////////////////////////////////////////////////////////
#include <e51pro.h>

#define C2051_P3_7	P1_0
#define C2051_P1	P0//ע෴
#define C2051_P3_0 	P1_1
#define C2051_P3_1	P1_2
#define C2051_XTAL	P1_4
#define C2051_P3_2	P1_5
#define C2051_P3_3	P1_6
#define C2051_P3_4	P1_7
#define C2051_P3_5	P3_5
 
void InitPro01()//ǰ׼
{
	SetVpp0V();
	P0=0xff;
	P1=0xff;
	C2051_P3_5=1;
	C2051_XTAL=0;
	Delay_ms(20);
	nAddress=0x0000;
	SetVpp5V();
}

void ProOver01()//̽Ĺúʵŵƽ
{
	SetVpp5V();
	P0=0xff;
	P1=0xff;
	C2051_P3_5=1;
	C2051_XTAL=1;
}

BYTE GetData()//P0ڻ
{
	B_0=P0_7;
	B_1=P0_6;
	B_2=P0_5;
	B_3=P0_4;
	B_4=P0_3;
	B_5=P0_2;
	B_6=P0_1;
	B_7=P0_0;
	return B;
}

void SetData(BYTE DataByte)//תP0ڵ
{
	B=DataByte;
	P0_0=B_7;
	P0_1=B_6;
	P0_2=B_5;
	P0_3=B_4;
	P0_4=B_3;
	P0_5=B_2;
	P0_6=B_1;
	P0_7=B_0;
}


void ReadSign01()//
{
	InitPro01();
	Delay_ms(1);
//-----------------------------------------------------------------------------
	//DataSheetӦı̿ź
	C2051_P3_3=0;
	C2051_P3_4=0;
	C2051_P3_5=0;
	C2051_P3_7=0;
	Delay_ms(20);
	ComBuf[2]=GetData();
	C2051_XTAL=1;
	C2051_XTAL=0;
	Delay_us(20);
	ComBuf[3]=GetData();
	ComBuf[4]=0xff;
//-----------------------------------------------------------------------------
	ProOver01();
}

void Erase01()//
{
	InitPro01();
//-----------------------------------------------------------------------------
	//DataSheetӦı̿ź
	C2051_P3_3=1;
	C2051_P3_4=0;
	C2051_P3_5=0;
	C2051_P3_7=0;
	Delay_ms(1);
	SetVpp12V();
	Delay_ms(1);
	C2051_P3_2=0;
	Delay_ms(10);
	C2051_P3_2=1;
	Delay_ms(1);
//-----------------------------------------------------------------------------
	ProOver01();
}

BOOL Write01(BYTE Data)//д
{
//-----------------------------------------------------------------------------
	//DataSheetӦı̿ź
	//дһԪ
	C2051_P3_3=0;
	C2051_P3_4=1;
	C2051_P3_5=1;
	C2051_P3_7=1;
	SetData(Data);
	SetVpp12V();
	Delay_us(20);
	C2051_P3_2=0;
	Delay_us(20);
	C2051_P3_2=1;
	Delay_us(20);
	SetVpp5V();
	Delay_us(20);
	C2051_P3_4=0;
	Delay_ms(2);
	nTimeOut=0;
	P0=0xff;
	nTimeOut=0;
	while(!GetData()==Data)//Ч:ѭֱдͬ
	{
		nTimeOut++;
		if(nTimeOut>1000)//ʱ
		{
			return 0;
		}
	}
	C2051_XTAL=1;
	C2051_XTAL=0;//һָһԪ
//-----------------------------------------------------------------------------
	return 1;
}

BYTE Read01()//
{
	BYTE Data;
//-----------------------------------------------------------------------------
	//DataSheetӦı̿ź
	//һԪ
	C2051_P3_3=0;
	C2051_P3_4=0;
	C2051_P3_5=1;
	C2051_P3_7=1;
	Data=GetData();
	C2051_XTAL=1;
	C2051_XTAL=0;//һָһԪ
//-----------------------------------------------------------------------------
	return Data;
}

void Lock01()//дλ
{
	InitPro01();//óɱ״̬
//-----------------------------------------------------------------------------
	//DataSheetӦı̿ź
	if(ComBuf[2]>=1)//ComBuf[2]Ϊλ
	{
		C2051_P3_3=1;
		C2051_P3_4=1;
		C2051_P3_5=1;
		C2051_P3_7=1;
		Delay_us(20);
		SetVpp12V();
		Delay_us(20);
		C2051_P3_2=0;
		Delay_us(20);
		C2051_P3_2=1;
		Delay_us(20);
		SetVpp5V();
	}
	if(ComBuf[2]>=2)
	{
		C2051_P3_3=1;
		C2051_P3_4=1;
		C2051_P3_5=0;
		C2051_P3_7=0;
		Delay_us(20);
		SetVpp12V();
		Delay_us(20);
		C2051_P3_2=0;
		Delay_us(20);
		C2051_P3_2=1;
		Delay_us(20);
		SetVpp5V();
	}
//-----------------------------------------------------------------------------
	ProOver01();
}

void PreparePro01()//pwеĺָ룬Եĺ
{
	pw.fpInitPro=InitPro01;
	pw.fpReadSign=ReadSign01;
	pw.fpErase=Erase01;
	pw.fpWrite=Write01;
	pw.fpRead=Read01;
	pw.fpLock=Lock01;
	pw.fpProOver=ProOver01;
}