//////////////////////////////////////////////////////////////////////////////////////////////////
//E51Pro.c
//Easy 51Pro򣬸ͨѶ̲
///////////////////////////////////////////////////////////////////////////////////////////////////

#include <E51Pro.h>

BYTE ComBuf[18];//ͨѶݻ棬ͺͽնʹ
UINT nAddress;//ROMеַ
UINT nTimeOut;//ʱ
ProWork pw;//һ

void Delay_us(BYTE nUs)//΢뼶ʱ<255us
{
	TH0=0;
	TL0=0;
	TR0=1;
	while(TL0<nUs)//T0ʱѭֱﵽʱֵ
	{
	}
	TR0=0;
}

void Delay_ms(UINT nMs)//뼶ʱ<65535ms
{
	UINT n=0;
	TR0=1;
	while(n<nMs)////T0ʱѭֱﵽʱֵ
	{
		TH0=0;
		TL0=20;
		while(TH0<4)
		{
		}
		n++;
	}
	TR0=0;
}
 
BOOL WaitComm()//ȴλ,18ֽ
{
	BYTE n=0;
	RI=0;
	while(!RI){}//ȴһֽ
	ComBuf[n]=SBUF;
	RI=0;
	n++;
	for(n;n<=17;n++)
	{
		nTimeOut=0;
		while(!RI)
		{
			nTimeOut++;
			if(nTimeOut>10000)//17ֽڶгʱ 
				return 0;
		}
		ComBuf[n]=SBUF;
		RI=0;
	}
	return 1;
}

BOOL WaitResp()//ȴλӦ,1ֽ,гʱ 
{
	nTimeOut=0;
	RI=0;
	while(!RI)
	{
		nTimeOut++;
		if(nTimeOut>50000) 
		{
			return 0;
		}
	}
	RI=0;
	ComBuf[0]=SBUF;
	return 1;
}

BOOL WaitData()//дʱȴλݣ18ֽڣгʱ 
{
	BYTE n;
	RI=0;
	for(n=0;n<=17;n++)
	{
		nTimeOut=0;
		while(!RI)
		{
			nTimeOut++;
			if(nTimeOut>10000)
			{
				return 0;
			}
		}
		RI=0;
		ComBuf[n]=SBUF;
	}
	return 1;
}

void SendData()//ݻӦ,18ֽ
{
	BYTE n=0;
	for(n;n<=17;n++)
	{
		TI=0;
		SBUF=ComBuf[n];
		while(!TI){}
		TI=0;
	}
}

void SendResp()//Ӧλ1ֽ,дʹ
{
	TI=0;
	SBUF=ComBuf[0];
	while(!TI){}
	TI=0;
}

void SetVpp5V()//VppΪ5v
{
	P3_4=0;
	P3_3=0;
}

void SetVpp0V()//VppΪ0v
{
	P3_3=0;
	P3_4=1;
}

void SetVpp12V()//VppΪ12v
{
	P3_4=0;
	P3_3=1;
}

void RstPro()//λ
{
	pw.fpProOver();//ֱӱ̽
	SendData();//֪ͨλʾֱô˺ΪЭţComBuf[0]û޸ģͬ
}

void ReadSign()//
{
	pw.fpReadSign();
	SendData();//֪ͨλͳ
}

void Erase()//
{
	pw.fpErase();
	SendData();//֪ͨλ
}

void Write()//д
{
	BYTE n;
	pw.fpInitPro();//ǰ׼
	SendData();//Ӧλʾд״̬Է
	while(1)
	{
		if(WaitData())//ȴݳɹ
		{
			if(ComBuf[0]==0x07)//жǷд
			{
				for(n=2;n<=17;n++)//ComBuf[2~17]Ϊдݿ
				{
					if(!pw.fpWrite(ComBuf[n]))//<<<<<<<<<<<<<<<<<<<дһԪĺ
					{
						pw.fpProOver();//˾ͽ
						ComBuf[0]=0xff;
						SendResp();//Ӧλһֽڣʾдݳ
						WaitData();//ȴλĻӦͽ
						return;	
					}
					nAddress++;//һԪ
				}
				ComBuf[0]=1;//Ӧλһֽڣʾݿ˳ɣ
				SendResp();
			}
			else if(ComBuf[0]==0x00)//д
				break;
			else//ͨѶ
			{
				pw.fpProOver();
				return;
			}
		}
		else//ȴʧ
		{
			pw.fpProOver();
			return;
		}
	}
	pw.fpProOver();//̽Ĺ
	Delay_ms(50);//ʱȴλд߳̽
	ComBuf[0]=0;//֪ͨλ״̬
	SendData();
}

void Read()//
{
	BYTE n;
	pw.fpInitPro();//óɱ״̬
	SendData();//Ӧλʾ״̬
	while(1)
	{
		if(WaitResp())//ȴλӦ1ֽ
		{
			if(ComBuf[0]==0)//ComBuf[0]==0ʾ
			{
				break;
			}
			else if(ComBuf[0]==0xff)//0xffʾط
			{
				nAddress=nAddress-0x0010;
			}
			for(n=2;n<=17;n++)//ComBuf[2~17]ݿ
			{
				ComBuf[n]=pw.fpRead();//<<<<<<<<<<<<<<<<<<<дһԪĺ
				nAddress++;//һԪ
			}
			ComBuf[0]=6;//λͶݿ
			SendData();
		}
		else
			break;//ȴӦʧ	

	}
	pw.fpProOver();//Ϊ״̬
	ComBuf[0]=0;//֪ͨλ״̬
	SendData();
}

void Lock()//дλ
{
	pw.fpLock();
	SendData();
}

///////////////////////////////////////////////////////////////////////////////////////////////////
//ֵ֧FID,
///////////////////////////////////////////////////////////////////////////////////////////////////
extern void PreparePro00();//FID=00:AT89C51
extern void PreparePro01();//FID=01:AT89C2051
extern void PreparePro02();//FID=02:AT89S51

void main()
{
	SP=0x60;
	SetVpp5V();//ȳʼVppΪ5v
	SCON=0x00;
	TCON=0x00;
	//PCON=0x00;//*2
	IE=0x00;
	//TMOD: GATE|C/!T|M1|M0|GATE|C/!T|M1|M0
	//        0    0   1  0   0    0   0  1
	TMOD=0x21;//T0ʱ
	TH1=0xff;
	TL1=0xff;//28800*2,עPCON
	//SCON: SM0|SM1|SM2|REN|TB8|RB8|TI|RI
    //        0   1   0   1   0   0  0  0
	SCON=0x50;
	TR1=1;
	Delay_ms(1000);//ʱ1Ծ
	ComBuf[0]=0;
	SendData();
 	while(1)//ͨѶòѯʽ
	{
		if(!WaitComm())//ʱ,ͨѶ
		{
			Delay_ms(500);
			ComBuf[0]=0;//ñλ,ʹ
		}
		switch(ComBuf[1])//FID(ProWork)pwеĺָ
		{
			case 0://at89c51
				PreparePro00();
				break;
			case 1://at89c2051
				PreparePro01();
				break;
			case 2://at89s51
				PreparePro02();
				break;
			//case 3:֧ʱ
			//	break;
			//case 4:
			//	break;
			default:
				ComBuf[0]=0xff;
				ComBuf[1]=0xff;//ʾЧĲ
				break;
		}
		switch(ComBuf[0])//ݲIDͬĲ
		{
			case 0x00:
				RstPro();//λ
				break;
			case 0x01:
				ReadSign();//
				break;
			case 0x02:
				Erase();//
				break;
			case 0x03:
				Write();//д
				break;
			case 0x04:
				Read();//
				break;
			case 0x05:
				Lock();//дλ
				break;
			default:
				SendData();
				break;
		}
	}
}


