// Pro.h: interface for the CPro class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_PRO_H__3915F601_F041_11D7_A019_9806402060C0__INCLUDED_)
#define AFX_PRO_H__3915F601_F041_11D7_A019_9806402060C0__INCLUDED_

#include "StdAfx.h"	// Added by ClassView
#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

//CPro:.
#define		WM_PRO_MSG				WM_USER+20
#define		PRO_INIT_SERIAL_ER		0//ʼڳ
#define		PRO_INIT_PARALLEL_ER	1//ʼڳ
#define		PRO_INIT_SERIAL_SEC		2//ʼڳɹ
#define		PRO_INIT_SERIAL_NOT		3//δʼ
#define		PRO_INIT_PARALLEL_SEC	4//ʼڳɹ
#define		PRO_AVAILABLE			5//豸
#define		PRO_INVALID				6//豸
#define		PRO_RCV_ER				7//ݳ

#define		PRO_RD_SIGN				8//Ѷ
#define		PRO_ERASE				9//߳
#define		PRO_WRITE_BEGIN			10//дʼ
#define		PRO_WRITE_BLOCK			11//дһ
#define		PRO_WRITE_OVER			12//д
#define		PRO_WRITE_ER			13//дݳ
#define		PRO_READ_BEGIN			14//ʼ
#define		PRO_READ_BLOCK			15//һ
#define		PRO_READ_OVER			16//
#define		PRO_LOCK_BIT			17//дλ
#define		PRO_WORK_INVALID		18//Ч
#define		PRO_DETECTCHIP_SEC		19//ҵƥ
#define		PRO_DETECTCHIP_ER		20//ûҵƥ

#include "SerialPro.h"
#include "ParallelPro.h"

class CEProDlg; 
class CPro  
{
public:
	BOOL m_bCheck;//ǷЧ
	int m_nChipSel;//ѡбеλ
	ChipType* GetCurChip();//õǰ
	BOOL CheckChip();//Ƿҵ֮ƥ
	int GetMinLength(BYTE* pBuf,int nLength);//õСݿ鳤
	ChipType* GetChipType(int nChipSel);//õ
	void LoadChipList();//б
	void LockBit(int nChipSel,int nBit);//дλ
	void Read(int nChipSel);//
	void Write(int nChipSel);//д
	void Erase(int nChipSel);//
	void DetectChip(int nChipSel);//
	void DetectPro(int nChipSel);//
	void Notify(int nInfo);//֪ͨϢ
	BOOL InitPro(CWnd*	pWnd,int nProType,int nIspSpd=0);//ʼ
	int m_nProType;//
	int m_nSerialPort;//ڶ˿
	int m_nBaudSel;//
	int m_nAddr;//ǰдĵַ
	int m_nDataLength;//дݿĳ
	CArray<ChipType*,ChipType*> m_arChips;//ͺſ
	BYTE* m_pWriteBuf;//д
	BYTE* m_pReadBuf;//
	BYTE  SignByte[3];//ֻ
	CPro();
	CEProDlg*	m_pDlg;//Ի
	virtual ~CPro();
	CSerialPro*	m_pSerialPro;//б
	CParallelPro* m_pParlPro;//ʹòڵı
};

#endif // !defined(AFX_PRO_H__3915F601_F041_11D7_A019_9806402060C0__INCLUDED_)
